# 显示模块

![按数字进行绘制](item:tis3d:module_display)

显示模块提供了一套高度灵活的方法，可用于在二维有色网格中以可视化方法呈现任意数据(编者注：孩子们喜欢叫他们“像素”)。通过向显示模块的任意一个端口写入一个数字序列，你可以改变这些单元的颜色。这个数字序列包含了将要填充的矩形的颜色码，位置和大小。

显示模块将从它的4个端口中不断读取数据，每五个值组成一次绘制调用。一旦一个绘制调用所需的五个数字都被接收，所描述的矩形将会被绘制到到彩色网格中。

## 绘制技术规范
显示模块收到5个值组成的序列，会被依次解释为这些绘制调用的参数：颜色、列、行、宽度和高度。网格是由28行和28列组成的正方形。颜色的值由固定的颜色表决定。
确切的颜色值可能因供应商而异，但一般颜色名称遵循这个世界的规范：
- `0`: 白色
- `1`: 橙色
- `2`: 品红
- `3`: 浅蓝
- `4`: 黄色
- `5`: 黄绿
- `6`: 粉色
- `7`: 灰色
- `8`: 银白
- `9`: 青色
- `10`: 紫色
- `11`: 蓝色
- `12`: 棕色
- `13`: 绿色
- `14`: 红色
- `15`: 黑色

提供非法的颜色和坐标会引起未定义的行为，但是由于供应商处理谨慎，总体上都会被妥善解决。

下面是一个简单的程序，可以绘制不同颜色的竖线：
`MOV 16 ACC`
`LOOP:`
`SUB 1`
`MOV ACC LEFT # COLOR`
`MOV ACC LEFT # X`
`MOV 0 LEFT # Y`
`MOV 1 LEFT # WIDTH`
`MOV 28 LEFT # HEIGHT`
`JNZ LOOP`
