# 定时器模块

![该死的，时间差不多了](item:tis3d:module_timer)

定时器模块使用了一种高精度的石英，来提供一种连续而可靠的计时操作。它的硬件按照20赫兹的时钟周期运行。这意味着一个时钟周期是精准的50毫秒。计时器的时钟也按照这一频率运行。

定时器模块连续地从四个端口中读取数据。当数值被成功读取之后，内部的计时器状态就会被设置为这个数值，并且在将来的每个时钟周期内递减。当它变成零时，模块就会持续向4个端口输出一个常量，这个数值取决于具体的实现。

由于定时器模块只会在计数归零时产生输出，所以用户可以利用这个特性让程序等待特定长度的时间，只需要让程序尝试从定时器模块中读取数据即可。鉴于TIS-3D电脑 的阻塞通讯模式，这个读取的操作将会被阻塞，直到定时器计数归零。

在使用上文叙述的阻塞策略时，用户可以实现外部中断的操作。需要做的配置只是让[执行模块](module_execution.md)从`ANY`端口进行读 取。需要中断阻塞时，使用另外的[执行模块](module_execution.md)向被阻塞的执行模块写入一个数值，即可解除该模块的中断状态。

## 时长转换表
为了便于使用，我们提供了一个时长转换的速查表。对于下列的常用时长，使用给出的数值即可配置定时器模块。

半秒： 10
一秒： 20
五秒： 100
十秒： 200
一分钟： 1200
十五分钟： 18000
半小时： 36000

最大的定时周期受限于TIS-3D电脑的端口带宽，也就是 16位。因此，最大的配置参数是0xFFFF，也就对应着54分钟36秒又750毫秒。
